package principal;

import java.util.Scanner;

public class GerenciaPessoas {
	private Pessoa[] vetPessoas;
	private Scanner e;
	
	public GerenciaPessoas(Pessoa vet[]) {
		vetPessoas = vet;
		e = new Scanner(System.in);
	}
	
	public void incluir() {
		int pos;
		
		System.out.println("---==[ Inclusão ]==---");
		
		// Percorre o vetor em busca da primeira posição vazia.
		pos = 0;
		while((pos < vetPessoas.length) && (vetPessoas[pos] != null)) {
			pos++;
		}
		
		if(pos < vetPessoas.length) {
			Pessoa p = new Pessoa();

			System.out.println("- Digite os dados a seguir: -");
			System.out.println("- Nome: ");
			p.setNome(e.nextLine());
			System.out.println("- Telefone 1: ");
			p.setTelefone1(e.nextLine());
			System.out.println("- Telefone 2: ");
			p.setTelefone2(e.nextLine());
			System.out.println("- Telefone 3: ");
			p.setTelefone3(e.nextLine());
			System.out.println("- Logradouro: ");
			p.setLogradouro(e.nextLine());
			System.out.println("- Número: ");
			p.setNumero(e.nextInt());
			e.skip("\n");
			System.out.println("- Bairro: ");
			p.setBairro(e.nextLine());
			System.out.println("- Município: ");
			p.setMunicipio(e.nextLine());
			System.out.println("- C.E.P.: ");
			p.setCep(e.nextLine());

			vetPessoas[pos] = p;
		}
		else {
			System.out.println("Memória cheia.");
		}
	}
	
	public void excluir() {
		int pos, resp;
		
		System.out.println("---==[ Exclusão ]==---");
		System.out.println("Digite a posição para exclusão: ");
		pos = e.nextInt();
		e.skip("\n");
		
		if((pos >= 0) && (pos < vetPessoas.length)) {
			if(vetPessoas[pos] != null) {
				System.out.println("Dados da pessoa escolhida: ");
				imprimir(vetPessoas[pos]);
				
				System.out.println("Confirma a exclusão? (1-sim/2-não)");
				resp = e.nextInt();
				e.skip("\n");
				
				if(resp == 1) {
					vetPessoas[pos] = null;
					System.out.println("Pessoa excluída com sucesso.");
				}
				else {
					System.out.println("Pessoa não excluída.");
				}
			}
			else {
				System.out.println("Posição vazia.");
			}
		}
		else {
			System.out.println("Posição inválida!");
		}
	}
	
	public void alterar() {
		int pos;
	
		System.out.println("---==[ Alteração ]==---");

		System.out.println("Digite a posição para alteração: ");
		pos = e.nextInt();
		e.skip("\n");
		
		if((pos >= 0) && (pos < vetPessoas.length)) {
			if(vetPessoas[pos] != null) {
				System.out.println("Dados da pessoa escolhida: ");
				
				// Pego a referência do objeto Pessoa que está no vetor.
				Pessoa p = vetPessoas[pos]; 
				
				imprimir(p);
				
				System.out.println("- Digite os novos dados: ");
				System.out.println("- Nome: ");
				p.setNome(e.nextLine());
				System.out.println("- Telefone 1: ");
				p.setTelefone1(e.nextLine());
				System.out.println("- Telefone 2: ");
				p.setTelefone2(e.nextLine());
				System.out.println("- Telefone 3: ");
				p.setTelefone3(e.nextLine());
				System.out.println("- Logradouro: ");
				p.setLogradouro(e.nextLine());
				System.out.println("- Número: ");
				p.setNumero(e.nextInt());
				e.skip("\n");
				System.out.println("- Bairro: ");
				p.setBairro(e.nextLine());
				System.out.println("- Município: ");
				p.setMunicipio(e.nextLine());
				System.out.println("- C.E.P.: ");
				p.setCep(e.nextLine());

				System.out.println("Alteração efetuada com sucesso.");
			}
			else {
				System.out.println("Posição vazia.");
			}
		}
		else {
			System.out.println("Posição inválida!");
		}
	}
	
	public void consultar() {
		int pos;

		System.out.println("---==[ Consulta ]==---");
		
		System.out.println("Digite a posição para consulta: ");
		pos = e.nextInt();
		e.skip("\n");
		
		if((pos >= 0) && (pos < vetPessoas.length)) {
			if(vetPessoas[pos] != null) {
				System.out.println("Dados da pessoa escolhida: ");
				imprimir(vetPessoas[pos]);
			}
			else {
				System.out.println("Posição vazia.");
			}
		}
		else {
			System.out.println("Posição inválida!");
		}
	}
	
	public void relatorio() {
		System.out.println("---==[ Relatório ]==---");
		
		for(int i = 0; i < vetPessoas.length; i++) {
			if(vetPessoas[i] != null) {
				imprimir(vetPessoas[i]);
				System.out.println("---------------");
			}
		}
	}
	
	private void imprimir(Pessoa pess) {
		System.out.println("- Nome      : " + pess.getNome());
		System.out.println("- Telefone 1: " + pess.getTelefone1());
		System.out.println("- Telefone 2: " + pess.getTelefone2());
		System.out.println("- Telefone 3: " + pess.getTelefone3());
		System.out.println("- Logradouro: " + pess.getLogradouro());
		System.out.println("- Número    : " + pess.getNumero());
		System.out.println("- Bairro    : " + pess.getBairro());
		System.out.println("- Município : " + pess.getMunicipio());
		System.out.println("- C.E.P.    : " + pess.getCep());
	}
}